package com.loafle.overflow.crawler.result;

import com.loafle.overflow.crawler.config.Item;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by root on 17. 4. 25.
 */
public class OFResultSetCol extends OFResultSet{


    public OFResultSetCol(Item item) {
        super(item);
    }

    public void setMeta() {

        List<String> meta = this.item.getQuery().getKeys();

        if(this.meta == null) {
            this.meta = new HashMap<>();
        }

        for(int indexI = 0; indexI < meta.size(); ++indexI) {
            this.meta.put(meta.get(indexI), indexI);
        }

    }

    public Map<String, String> parse() {

        List<String> metrics = this.item.getMetrics();
        String[] arrayColumns = (String[])this.item.getQuery().getQueryInfo().get("arrayColumns");
//        this.meta

        Map<String, String> resultMap = new HashMap<>();

        List<String> row = null;

        String metric = null;
        List<String> arrayValue = new ArrayList<>();


        int columnIdx = 0;

        for(int indexI = 0; indexI < this.rows.size(); ++indexI) {

            row = this.rows.get(indexI);
            for (int indexJ= 0; indexJ < row.size(); ++indexJ) {

                arrayValue.clear();

                for(int indexL =0; indexL < arrayColumns.length; ++indexL) {
                    columnIdx = this.meta.get(arrayColumns[indexL]);

                    arrayValue.add(row.get(columnIdx));
                }


                for(int indexK = 0 ; indexK < metrics.size(); ++indexK) {

                    metric = metrics.get(indexK);

                    metric = convertMetric(metric, arrayValue);

                    resultMap.put(metric, row.get(indexI));
                }

            }

        }

        return resultMap;

    }

    private String convertMetric(String metric, List<String> arrayValue) {

        char convertChar = '$';
        String convertStr = "$";

        for(int indexI = 0 ; indexI < arrayValue.size(); ++indexI) {

            convertStr = convertChar + String.valueOf(indexI +1);

            metric = metric.replaceFirst(convertStr, arrayValue.get(indexI));

        }

        return metric;
    }
}
